require 'wrapper/errors'
require 'wrapper/image'

require 'rest-client'
require 'json'

# API Wrapper em Ruby, para Naeg.in
class NaeginClient
  # Cria uma instancia de NaeginClient
  def initialize(token)
    raise InvalidToken, 'Tokens devem ser Strings' unless token.is_a? String

    @url = "https://api.naeg.in/%s?token=#{token}"
  end

  # Lista todas as Tags disponiveis para uso, retornando uma array
  def tags
    data = JSON.parse(RestClient.get(@url % 'tags').body)

    raise InvalidAPIResponse, data['mensagem'] if data['erro']

    data['tags']
  end

  # Retorna um objeto NaeginImage, levando 'url', 'nsfw' e 'gif' como atributos.
  def random_image(tag, nsfw: nil, gif: nil)
    url = "#{@url % 'img'}&tag=#{tag}"
    url += "&nsfw=#{nsfw}" if nsfw.is_a?(TrueClass) || nsfw.is_a?(FalseClass)
    url += "&gif=#{gif}" if gif.is_a?(TrueClass) || gif.is_a?(FalseClass)

    data = JSON.parse(RestClient.get(url).body)

    raise InvalidAPIResponse, data['mensagem'] if data['erro']

    NaeginImage.new(data)
  end
end
